// -----------------------------------------------------------------------------
// File: bee.ss
// Description: Bee enemy script
// License: MIT
// -----------------------------------------------------------------------------
using SurgeEngine.Actor;
using SurgeEngine.Player;
using SurgeEngine.Vector2;
using SurgeEngine.Transform;

using SurgeEngine.Behavior.Enemy;
using SurgeEngine.Behavior.DirectionalMovement;
using SurgeEngine.Collisions.CollisionBox;

object "Bee" is "entity", "enemy"
{
	actor = Actor("Bee");
	enemy = Enemy();
	movement = DirectionalMovement();
	transform = Transform();
	elapsedTime = 0;
	
	state "main"
	{
		player = Player.active;
		distance = transform.position.distanceTo(player.transform.position);
		
		if(transform.position.x > Player.active.transform.position.x)
			actor.hflip = true;
		else
			actor.hflip = false;
			
		// up-down movement
		movement.direction = Vector2.up;
		movement.speed = 20 * Math.cos(3.1416 * elapsedTime);
		elapsedTime += Time.delta;
		
		if(distance <= 76)
			state = "chasing";
	}
	
	state "chasing"
	{
		state = "chasing2";
	}
	
	state "chasing2"
	
	{
		player = Player.active;
		
		//look at the player
		if(transform.position.x > player.transform.position.x)
			actor.hflip = true;
		else
			actor.hflip = false;	
	
		
		// chase the player
		
		actor.anim = 1;
		movement.direction = transform.position.directionTo(player.transform.position);
		movement.speed = 80;
	}
}