//
// This is a swimming move that should be configured as a
// companion object in Speedy's character definition file (.chr)
//
// When you are underwater, jump and press fire5.
// Speedy will swim and if you press fire5 repeatdly he will keep swimming!
//

using SurgeEngine.Player;

object "Speedy Swim"
{
    player = parent;
	timeMidAir = 0;

    state "main"
    {
        state = "nounderwater";
    }

    state "nounderwater" // out of water

    {
        if(player.underwater) {
            state = "underwater";
        }
    }

    state "underwater" // underwater but not swimming
    {
        timeMidAir += (player.midair ? Time.delta : -timeMidAir);
		if(timeMidAir >= 0.1 && player.underwater && !player.hit) {
			if(player.input.buttonPressed("fire1")) {
				state = "swim";
			}
			else if(!player.underwater) {
				state = "nounderwater";
			}
		}
    }

    state "swim" // swimming
    {
        player.springify(); // make it vulnerable to attack
        player.anim = 21;
        player.ysp = -90;
        state = "swim2";
    }

    state "swim2"
    {
        player.anim = 21;
        if(!player.underwater) { // got out of water
            state = "nounderwater";
        }
        else if(!player.midair) { // landed on the ground
            state = "underwater";
        }
        else if(player.input.buttonPressed("fire1")) { // swim more
            state = "swim";
        }
		else if(player.dying) {
			destroy();
		}
    }
}