using SurgeEngine.Player;
using SurgeEngine.Input;
using SurgeEngine.Actor;
using SurgeEngine.Transform;
using SurgeEngine.Collisions.Sensor;

object "Wallkick" is "companion"
{
	player = parent;
	input = player;
	rightSensor = Sensor(15, -20, 1, 5);
	leftSensor = Sensor(-15, -20, 1, 5);
	
	state "main"
	{
		if((player.jumping || player.springing) && !player.underwater && !player.slope) {
			if(rightSensor.status == "solid") {
				if(player.direction == +1) {
					if(player.input.buttonPressed("fire1")) {
						state = "wallkick";
					}
				}
			}
			if(leftSensor.status == "solid") {
				if(player.direction == -1) {
					if(player.input.buttonPressed("fire1")) {
						state = "wallkick2";
					}
				}
			}
		}
	}
	
	state "wallkick"
	{
		if(player.direction == +1) {
			player.frozen = true;
			state = "stuck";
		}
	}
	
	state "wallkick2"
	{
		if(player.direction == -1) {
			player.frozen = true;
			state = "stuck2";
		}
	}
	
	state "stuck"
	{
		player.anim = 23;
		if(player.input.buttonPressed("down")) {
			player.frozen = false;
			state = "main";
		}
		if(player.input.buttonPressed("fire1")) {
			boost();
		}
	}
	
	state "stuck2"
	{
		player.anim = 23;
		if(player.input.buttonPressed("down")) {
			player.frozen = false;
			state = "main";
		}
		if(player.input.buttonPressed("fire1")) {
			boost2();
		}
	}
	
	state "jump"
	{
		player.anim = 3;
		player.frozen = false;
		state = "main";
	}
	
	fun constructor()
	{
		rightSensor.visible = false;
		leftSensor.visible = false;
	}
	
	fun boost()
	{
		player.ysp = -500;
		player.xsp = -300;
		state = "jump";
	}
	
	fun boost2()
	{
		player.ysp = -500;
		player.xsp = 300;
		state = "jump";
	}
}
