//
// We modify Speedy's animation:
// 1. when he falls down after hitting a spring
// 2. after breathing an air bubble
//

using SurgeEngine.Player;

object "Zippy Falling" is "companion"
{
    player = Player("Zippy");
    falling = 20;
    springing = 13;

    state "main"
    {
        // The player may be in the springing state,
        // but that alone doesn't mean he has just
        // been hit by a spring. We use the springing
        // state to create other things, like the double
        // jump, so we need to check player.anim as well
        if(player.springing && player.anim == springing)
            state = "watching";

        // From breathing to falling
        else if(player.breathing)
            state = "watching";
    }

    state "watching"
    {
        // Now the player is midair and will fall
        // down. We'll capture this event and
        // change the animation accordingly
        if(player.ysp >= 0 && player.midair) {
            player.anim = falling;
            state = "falling";
        }
        else if(!player.springing && !player.breathing)
            state = "main";
    }

    state "falling"
    {
        if(player.ysp >= 0 && player.midair)
            player.anim = falling;
        else
            state = "main";
    }
}